# coding: utf-8

"""
    Seldon Deploy API

    API to interact and manage the lifecycle of your machine learning models deployed through Seldon Deploy.  # noqa: E501

    OpenAPI spec version: v1alpha1
    Contact: hello@seldon.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class ExperimentSpec(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'candidates': 'list[ExperimentCandidate]',
        'default': 'str',
        'mirror': 'ExperimentMirror',
        'resource_type': 'ResourceType'
    }

    attribute_map = {
        'candidates': 'candidates',
        'default': 'default',
        'mirror': 'mirror',
        'resource_type': 'resourceType'
    }

    def __init__(self, candidates=None, default=None, mirror=None, resource_type=None):  # noqa: E501
        """ExperimentSpec - a model defined in Swagger"""  # noqa: E501

        self._candidates = None
        self._default = None
        self._mirror = None
        self._resource_type = None
        self.discriminator = None

        if candidates is not None:
            self.candidates = candidates
        if default is not None:
            self.default = default
        if mirror is not None:
            self.mirror = mirror
        if resource_type is not None:
            self.resource_type = resource_type

    @property
    def candidates(self):
        """Gets the candidates of this ExperimentSpec.  # noqa: E501


        :return: The candidates of this ExperimentSpec.  # noqa: E501
        :rtype: list[ExperimentCandidate]
        """
        return self._candidates

    @candidates.setter
    def candidates(self, candidates):
        """Sets the candidates of this ExperimentSpec.


        :param candidates: The candidates of this ExperimentSpec.  # noqa: E501
        :type: list[ExperimentCandidate]
        """

        self._candidates = candidates

    @property
    def default(self):
        """Gets the default of this ExperimentSpec.  # noqa: E501


        :return: The default of this ExperimentSpec.  # noqa: E501
        :rtype: str
        """
        return self._default

    @default.setter
    def default(self, default):
        """Sets the default of this ExperimentSpec.


        :param default: The default of this ExperimentSpec.  # noqa: E501
        :type: str
        """

        self._default = default

    @property
    def mirror(self):
        """Gets the mirror of this ExperimentSpec.  # noqa: E501


        :return: The mirror of this ExperimentSpec.  # noqa: E501
        :rtype: ExperimentMirror
        """
        return self._mirror

    @mirror.setter
    def mirror(self, mirror):
        """Sets the mirror of this ExperimentSpec.


        :param mirror: The mirror of this ExperimentSpec.  # noqa: E501
        :type: ExperimentMirror
        """

        self._mirror = mirror

    @property
    def resource_type(self):
        """Gets the resource_type of this ExperimentSpec.  # noqa: E501


        :return: The resource_type of this ExperimentSpec.  # noqa: E501
        :rtype: ResourceType
        """
        return self._resource_type

    @resource_type.setter
    def resource_type(self, resource_type):
        """Sets the resource_type of this ExperimentSpec.


        :param resource_type: The resource_type of this ExperimentSpec.  # noqa: E501
        :type: ResourceType
        """

        self._resource_type = resource_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ExperimentSpec, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ExperimentSpec):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
